AbstractMessageLite.Builder
Date: 2017-07-08

com.google.protobuf

## Class AbstractMessageLite.Builder<MessageType extends AbstractMessageLite<MessageType,BuilderType>,BuilderType extends AbstractMessageLite.Builder<MessageType,BuilderType>>

- java.lang.Object
- - com.google.protobuf.AbstractMessageLite.Builder<MessageType,BuilderType>

- All Implemented Interfaces:
    MessageLite.Builder, MessageLiteOrBuilder, java.lang.Cloneable
  Direct Known Subclasses:
    AbstractMessage.Builder, GeneratedMessageLite.Builder
  Enclosing class:
    AbstractMessageLite<MessageType extends AbstractMessageLite<MessageType,BuilderType>,BuilderType extends AbstractMessageLite.Builder<MessageType,BuilderType>>

      public abstract static class AbstractMessageLite.Builder<MessageType extends AbstractMessageLite<MessageType,BuilderType>,BuilderType extends AbstractMessageLite.Builder<MessageType,BuilderType>>
      extends java.lang.Object
      implements MessageLite.Builder

  A partial implementation of the `Message.Builder` interface which implements as many methods of that interface as possible in terms of other methods.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractMessageLite.Builder()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected static <T> void` | `addAll(java.lang.Iterable<T> values, java.util.Collection<? super T> list)` Adds the `values` to the `list`.
    `abstract BuilderType` | `clone()` Clones the Builder.
    `protected abstract BuilderType` | `internalMergeFrom(MessageType message)`
    `boolean` | `mergeDelimitedFrom(java.io.InputStream input)` Like `MessageLite.Builder.mergeFrom(InputStream)`, but does not read until EOF.
    `boolean` | `mergeDelimitedFrom(java.io.InputStream input, ExtensionRegistryLite extensionRegistry)` Like `MessageLite.Builder.mergeDelimitedFrom(InputStream)` but supporting extensions.
    `BuilderType` | `mergeFrom(byte[] data)` Parse `data` as a message of this type and merge it with the message being built.
    `BuilderType` | `mergeFrom(byte[] data, ExtensionRegistryLite extensionRegistry)` Parse `data` as a message of this type and merge it with the message being built.
    `BuilderType` | `mergeFrom(byte[] data, int off, int len)` Parse `data` as a message of this type and merge it with the message being built.
    `BuilderType` | `mergeFrom(byte[] data, int off, int len, ExtensionRegistryLite extensionRegistry)` Parse `data` as a message of this type and merge it with the message being built.
    `BuilderType` | `mergeFrom(ByteString data)` Parse `data` as a message of this type and merge it with the message being built.
    `BuilderType` | `mergeFrom(ByteString data, ExtensionRegistryLite extensionRegistry)` Parse `data` as a message of this type and merge it with the message being built.
    `BuilderType` | `mergeFrom(CodedInputStream input)` Parses a message of this type from the input and merges it with this message.
    `abstract BuilderType` | `mergeFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry)` Like `MessageLite.Builder.mergeFrom(CodedInputStream)`, but also parses extensions.
    `BuilderType` | `mergeFrom(java.io.InputStream input)` Parse a message of this type from `input` and merge it with the message being built.
    `BuilderType` | `mergeFrom(java.io.InputStream input, ExtensionRegistryLite extensionRegistry)` Parse a message of this type from `input` and merge it with the message being built.
    `BuilderType` | `mergeFrom(MessageLite other)` Merge `other` into the message being built.
    `protected static UninitializedMessageException` | `newUninitializedMessageException(MessageLite message)` Construct an UninitializedMessageException reporting missing fields in the given message.

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.protobuf.MessageLite.Builder

      `build, buildPartial, clear`

    - ### Methods inherited from interface com.google.protobuf.MessageLiteOrBuilder

      `getDefaultInstanceForType, isInitialized`

- - ### Constructor Detail

    - #### AbstractMessageLite.Builder

          public AbstractMessageLite.Builder()

  - ### Method Detail

    - #### clone

          public abstract BuilderType clone()

      Description copied from interface: `MessageLite.Builder`
      Clones the Builder.
      Specified by:
        `clone` in interface `MessageLite.Builder`
      Overrides:
        `clone` in class `java.lang.Object`
      See Also:
        `Object.clone()`

    - #### mergeFrom

          public BuilderType mergeFrom(CodedInputStream input)
                                                                                             throws java.io.IOException

      Description copied from interface: `MessageLite.Builder`
      Parses a message of this type from the input and merges it with this message.

      Warning: This does not verify that all required fields are present in the input message. If you call `MessageLite.Builder.build()` without setting all required fields, it will throw an `UninitializedMessageException`, which is a `RuntimeException` and thus might not be caught. There are a few good ways to deal with this:

      - Call `MessageLiteOrBuilder.isInitialized()` to verify that all required fields are set before building.
      - Use `buildPartial()` to build, which ignores missing required fields.

      Note: The caller should call `CodedInputStream.checkLastTagWas(int)` after calling this to verify that the last tag seen was the appropriate end-group tag, or zero for EOF.

      Specified by:
        `mergeFrom` in interface `MessageLite.Builder`
      Throws:
        `java.io.IOException`

    - #### mergeFrom

          public abstract BuilderType mergeFrom(CodedInputStream input,
                              ExtensionRegistryLite extensionRegistry)
                                                                                                      throws java.io.IOException

      Description copied from interface: `MessageLite.Builder`
      Like `MessageLite.Builder.mergeFrom(CodedInputStream)`, but also parses extensions. The extensions that you want to be able to parse must be registered in `extensionRegistry`. Extensions not in the registry will be treated as unknown fields.
      Specified by:
        `mergeFrom` in interface `MessageLite.Builder`
      Throws:
        `java.io.IOException`

    - #### mergeFrom

          public BuilderType mergeFrom(ByteString data)
                                                                                             throws InvalidProtocolBufferException

      Description copied from interface: `MessageLite.Builder`
      Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream)`.
      Specified by:
        `mergeFrom` in interface `MessageLite.Builder`
      Returns:
        this
      Throws:
        `InvalidProtocolBufferException`

    - #### mergeFrom

          public BuilderType mergeFrom(ByteString data,
                              ExtensionRegistryLite extensionRegistry)
                                                                                             throws InvalidProtocolBufferException

      Description copied from interface: `MessageLite.Builder`
      Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream,ExtensionRegistryLite)`.
      Specified by:
        `mergeFrom` in interface `MessageLite.Builder`
      Returns:
        this
      Throws:
        `InvalidProtocolBufferException`

    - #### mergeFrom

          public BuilderType mergeFrom(byte[] data)
                                                                                             throws InvalidProtocolBufferException

      Description copied from interface: `MessageLite.Builder`
      Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream)`.
      Specified by:
        `mergeFrom` in interface `MessageLite.Builder`
      Returns:
        this
      Throws:
        `InvalidProtocolBufferException`

    - #### mergeFrom

          public BuilderType mergeFrom(byte[] data,
                              int off,
                              int len)
                                                                                             throws InvalidProtocolBufferException

      Description copied from interface: `MessageLite.Builder`
      Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream)`.
      Specified by:
        `mergeFrom` in interface `MessageLite.Builder`
      Returns:
        this
      Throws:
        `InvalidProtocolBufferException`

    - #### mergeFrom

          public BuilderType mergeFrom(byte[] data,
                              ExtensionRegistryLite extensionRegistry)
                                                                                             throws InvalidProtocolBufferException

      Description copied from interface: `MessageLite.Builder`
      Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream,ExtensionRegistryLite)`.
      Specified by:
        `mergeFrom` in interface `MessageLite.Builder`
      Returns:
        this
      Throws:
        `InvalidProtocolBufferException`

    - #### mergeFrom

          public BuilderType mergeFrom(byte[] data,
                              int off,
                              int len,
                              ExtensionRegistryLite extensionRegistry)
                                                                                             throws InvalidProtocolBufferException

      Description copied from interface: `MessageLite.Builder`
      Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream,ExtensionRegistryLite)`.
      Specified by:
        `mergeFrom` in interface `MessageLite.Builder`
      Returns:
        this
      Throws:
        `InvalidProtocolBufferException`

    - #### mergeFrom

          public BuilderType mergeFrom(java.io.InputStream input)
                                                                                             throws java.io.IOException

      Description copied from interface: `MessageLite.Builder`
      Parse a message of this type from `input` and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream)`. Note that this method always reads the entire input (unless it throws an exception). If you want it to stop earlier, you will need to wrap your input in some wrapper stream that limits reading. Or, use `MessageLite.writeDelimitedTo(OutputStream)` to write your message and `MessageLite.Builder.mergeDelimitedFrom(InputStream)` to read it.

      Despite usually reading the entire input, this does not close the stream.

      Specified by:
        `mergeFrom` in interface `MessageLite.Builder`
      Returns:
        this
      Throws:
        `java.io.IOException`

    - #### mergeFrom

          public BuilderType mergeFrom(java.io.InputStream input,
                              ExtensionRegistryLite extensionRegistry)
                                                                                             throws java.io.IOException

      Description copied from interface: `MessageLite.Builder`
      Parse a message of this type from `input` and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream,ExtensionRegistryLite)`.
      Specified by:
        `mergeFrom` in interface `MessageLite.Builder`
      Returns:
        this
      Throws:
        `java.io.IOException`

    - #### mergeDelimitedFrom

          public boolean mergeDelimitedFrom(java.io.InputStream input,
                                   ExtensionRegistryLite extensionRegistry)
                                     throws java.io.IOException

      Description copied from interface: `MessageLite.Builder`
      Like `MessageLite.Builder.mergeDelimitedFrom(InputStream)` but supporting extensions.
      Specified by:
        `mergeDelimitedFrom` in interface `MessageLite.Builder`
      Throws:
        `java.io.IOException`

    - #### mergeDelimitedFrom

          public boolean mergeDelimitedFrom(java.io.InputStream input)
                                     throws java.io.IOException

      Description copied from interface: `MessageLite.Builder`
      Like `MessageLite.Builder.mergeFrom(InputStream)`, but does not read until EOF. Instead, the size of the message (encoded as a varint) is read first, then the message data. Use `MessageLite.writeDelimitedTo(OutputStream)` to write messages in this format.
      Specified by:
        `mergeDelimitedFrom` in interface `MessageLite.Builder`
      Returns:
        True if successful, or false if the stream is at EOF when the method starts. Any other error (including reaching EOF during parsing) will cause an exception to be thrown.
      Throws:
        `java.io.IOException`

    - #### mergeFrom

          public BuilderType mergeFrom(MessageLite other)

      Description copied from interface: `MessageLite.Builder`
      Merge `other` into the message being built. `other` must have the exact same type as `this` (i.e. `getClass().equals(getDefaultInstanceForType().getClass())`). Merging occurs as follows. For each field:
      * For singular primitive fields, if the field is set in `other`, then `other`'s value overwrites the value in this message.
      * For singular message fields, if the field is set in `other`, it is merged into the corresponding sub-message of this message using the same merging rules.
      * For repeated fields, the elements in `other` are concatenated with the elements in this message. * For oneof groups, if the other message has one of the fields set, the group of this message is cleared and replaced by the field of the other message, so that the oneof constraint is preserved. This is equivalent to the `Message::MergeFrom` method in C++.
      Specified by:
        `mergeFrom` in interface `MessageLite.Builder`

    - #### internalMergeFrom

          protected abstract BuilderType internalMergeFrom(MessageType message)

    - #### newUninitializedMessageException

          protected static UninitializedMessageException newUninitializedMessageException(MessageLite message)

      Construct an UninitializedMessageException reporting missing fields in the given message.

    - #### addAll

          protected static <T> void addAll(java.lang.Iterable<T> values,
                        java.util.Collection<? super T> list)

      Adds the `values` to the `list`. This is a helper method used by generated code. Users should ignore it.
      Throws:
        `java.lang.NullPointerException` - if `values` or any of the elements of `values` is null. When that happens, some elements of `values` may have already been added to the result `list`.